Unit QTS2R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure QTS2R(var RINT :Real; var X :Array of Real;
                var F :Array of Real; N :Integer);

implementation

procedure QTS2R(var RINT :Real; var X :Array of Real;
                var F :Array of Real; N :Integer);
var
N2,N3,I :Integer;
Y1,F12,B1,B2,A1,A2,A3 :Real;
label
_1,_2;
begin
RINT := 0.0;
N2 := 1;
N3 := N div 2;
N3 := N3*2;
if ( N3  <> N ) 
 then goto _1;
N2 := 2;
Y1 := (X[1]-X[0])/2.0;
F12 := F[0]*((Y1-X[1])*(Y1-X[2])*(Y1-X[3]))/((X[0]-X[1])*
    (X[0]-X[2])*(X[0]-X[3]))+F[1]*((Y1-X[0])*(Y1-X[2])*
    (Y1-X[3]))/((X[1]-X[0])*(X[1]-X[2])*(X[1]-X[3]))+F[2]*
    ((Y1-X[0])*(Y1-X[1])*(Y1-X[3]))/((X[2]-X[0])*(X[2]-
    X[1])*(X[2]-X[3]))+F[3]*((Y1-X[0])*(Y1-X[1])*(Y1-X[2])
    )/((X[3]-X[0])*(X[3]-X[1])*(X[3]-X[2]));
RINT := (F[0]+4.0*F12+F[1])*(Y1-X[0])/3.0;
_1:
B2 := X[N2+0]-X[N2-1];
N2 := N2+1;
I := N2;
while ( I<=N ) do
 begin
  B2 := X[I-1]-X[I-2];
  B1 := X[I+0]-X[I-1];
  A1 := X[I+0]-X[I-2];
  A2 := A1*A1;
  A3 := A1*B2/2.0;
  RINT := RINT+F[I-2]*(A3-A2/6.0)/B2+F[I-1]*(A2*A1/6.0)/(B2*B1)
    +F[I+0]*(A2/3.0-A3)/B1;
  B2 := B1;
_2:
  inc(I,2);
 end;
end;

end.
